#include <avr/io.h>
#include <util/delay.h>

#define STEP_GAUCHE 0x10 // pin 7
#define DIR_GAUCHE 0x08 // pin 6
#define STEP_DROIT 0x20 // pin 12
#define DIR_DROIT 0x10 // pin 11

const uint8_t deltaL[] = {};
const uint8_t delaiL[] = {};
const uint8_t deltaR[] = {};
const uint8_t delaiR[] = {};

#define GAUCHE 0
#define DROIT 1

void init_deplacements(void){
    DDRH |= STEP_GAUCHE | DIR_GAUCHE;
    DDRB |= STEP_DROIT | DIR_DROIT;
}

uint16_t* deplacement_commande_suivante(uint16_t num){
    return {deltaL[num], delaiL[num], deltaR[num], delaiR[num]};
}

void deplacement_moteur_gauche(uint16_t delta, uint16_t delai){ deplacement_moteur(GAUCHE, delta, delai); }
void deplacement_moteur_droit(uint16_t delta, uint16_t delai){ deplacement_moteur(DROIT, delta, delai); }
static void deplacement_moteur(uint8_t mot, uint16_t delta, uint16_t delai){
    for(uint16_t i=0; i<delta; i++){
        if (mot == GAUCHE)
            PORTH |= STEP_GAUCHE;
        else if (mot == DROIT)
            PORTB |= STEP_DROIT;
        _delay_ms(delai);
        if (mot == GAUCHE)
            PORTH &= ~STEP_GAUCHE;
        else if (mot == DROIT)
            PORTB &= ~STEP_DROIT;
        _delay_ms(delai);
    }
}
